设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 734|回复: 2

[图块] 【图块】批量绕插入点或几何中心点旋转指定的角度

[复制链接]

已领礼包: 20个

财富等级: 恭喜发财

发表于 2020-5-25 23:19:54 | 显示全部楼层 |阅读模式
  • 插件名称 : 选择旋转
  • 作  者 : marting
  • 运行环境 :XDRX API 晓东工具箱 
  • 发布时间 :2020-05-25
  • 命令名称 :xdtb_blkrot
  • 插件介绍 :【图块】批量绕插入点或几何中心点旋转指定的角度
  • 备  注 : (点击图片可以放大)
(点击图片可以放大)

晓东温馨提示 1、运行环境为 晓东工具箱XDRX API 的插件,请下载最新版本的 晓东工具箱XDRX API开发环境 一键安装
2、在ACAD中如何加载插件,请看 论坛插件使用方法
3、如果您有要求需要定制插件,请到 编程申请 论坛发帖求助

插件详细内容

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
  1. (defun c:xdtb_blkrot (/ x an x ss ang v)
  2.   (defun _callback (key) (setq #xd-var-global-rot-mode key) (_prompt))
  3.   (defun _prompt ()
  4.     (xdrx-prompt
  5.       "\n**当前方式: "
  6.       (cond ((= #xd-var-global-rot-mode "E") "绕中心点旋转")
  7.             (t "绕插入点旋转"))
  8.     )
  9.   )
  10.   (if (not #xd-var-global-rot-mode)
  11.     (setq #xd-var-global-rot-mode "A")
  12.   )
  13.   (if (not #xd-var-global-rot-angle)
  14.     (setq #xd-var-global-rot-angle 45))
  15.   (if (setq v (getreal (xdrx-prompt "\n输入原位旋转的角度<" #xd-var-global-rot-angle ">:" t)))
  16.     (setq #xd-var-global-rot-angle v))
  17.   (if
  18.     (and (xdrx-prompt
  19.            "\n将选中的块以各自的插入点为中心旋转指定的角度:"
  20.          )
  21.          (_prompt)
  22.          (xdrx-initget "E T")
  23.          (xdrx_initssget
  24.            "\n选取要旋转的图块[中心点(E)/插入点(T)]<退出>:"
  25.            "E T"
  26.            ""
  27.            "_callback"
  28.          )
  29.          (setq ss (xdrx-ssget '((0 . "insert"))))
  30.     )
  31.      (progn
  32.        (mapcar '(lambda        (x)
  33.                   (setq an (xdrx-getpropertyvalue x "rotation"))
  34.                   (cond        ((= #xd-var-global-rot-mode "T")
  35.                          (xdrx-setpropertyvalue
  36.                            x
  37.                            "rotation"
  38.                            (+ an (/ (* pi #xd-var-global-rot-angle) 180.0))
  39.                          )
  40.                         )
  41.                         (t
  42.                          (setq cen (trans (xd::geom:get9pt x 5) 1 0)
  43.                                mat (xdrx-matrix-setrotation (/ (* pi #xd-var-global-rot-angle) 180.0) '(0 0 1) cen ))
  44.                          (xdrx-entity-transform x mat)
  45.                         )
  46.                   )
  47.                 )
  48.                (xdrx-pickset->ents ss)
  49.        )
  50.      )
  51.   )
  52.   (princ)
  53. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 2个

财富等级: 恭喜发财

发表于 2020-6-11 13:52:59 | 显示全部楼层
可以一次批量转不同角度吗
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2个

财富等级: 恭喜发财

发表于 2021-2-2 17:53:28 | 显示全部楼层
xdtb_blkrot:批量绕插入点或几何中心点旋转指定的角度
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-9-21 15:21 , Processed in 0.869458 second(s), 35 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表